exodus/exodus/urls.py
from django.conf import settings
from django.urls import include, path
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin

from . import views

urlpatterns = [
    path('i18n/', include('django.conf.urls.i18n')),
    path('api/', include('restful_api.urls')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

urlpatterns += i18n_patterns(
    path('', views.index, name='home'),
    path('analysis/', include('analysis_query.urls')),
    path('trackers/', include('trackers.urls')),
    path('reports/', include('reports.urls')),
    path('info/permissions/', views.permissions, name='permissions'),
    path('info/trackers/', views.trackers, name='trackers'),
    path('info/next/', views.next, name='next'),
    path('info/understand/', views.understand, name='understand'),
    path('info/organization/', views.organization, name='organization'),
)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# handler404 = 'exodus.views.page_not_found'
# handler500 = 'exodus.views.page_not_found'

exodus/reports/urls.py
from django.urls import path
from django.views.generic import RedirectView

from . import views

app_name = 'reports'
urlpatterns = [
    path('', views.index, name='index'),
    path('list/', views.get_reports, name='list'),
    path('<int:report_id>/', views.detail, name='detail'),
    path('<int:app_id>/icon/', views.get_app_icon, name='icon'),
    path('stats/', RedirectView.as_view(pattern_name='trackers:get_stats', permanent=False)),
    path('search/<handle>/', views.get_reports, name='search_by_handle'),
    path('<handle>/latest/', views.detail, name='get_latest'),
    path('<handle>/latest/icon/', views.get_app_icon, name='icon_by_handle'),
]

exodus/trackers/urls.py
from django.urls import path

from . import views

app_name = 'trackers'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:tracker_id>/', views.detail, name='detail'),
    path('stats/', views.get_stats, name='get_stats'),
    path('graph/', views.graph, name='graph'),
    path('details/', views.TrackersListView.as_view(), name='all_details'),
]

exodus/trackers/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models


class TrackerCategory(models.Model):
    name = models.CharField(max_length=200)

    def __str__(self):
        return self.name


class Tracker(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField(blank=True)
    creation_date = models.DateField(auto_now_add=True)
    code_signature = models.CharField(max_length=500, blank=True, default='')
    network_signature = models.CharField(max_length=500, blank=True, default='')
    website = models.URLField()
    category = models.ManyToManyField(TrackerCategory, blank=True)
    apps_number = models.IntegerField(default=0)
    apps_percent = models.IntegerField(default=0)

    def __str__(self):
        return self.name

    def get_color_class(self):
        if self.apps_percent >= 50:
            tracker_class = "danger"
        elif self.apps_percent >= 33:
            tracker_class = "alert"
        elif self.apps_percent >= 20:
            tracker_class = "warning"
        else:
            tracker_class = "info"
        return tracker_class


class DetectionRule(models.Model):
    tracker = models.ForeignKey(Tracker, on_delete=models.CASCADE)
    pattern = models.CharField(max_length=500)
    description = models.CharField(max_length=20000)

    def __str__(self):
        return self.pattern

exodus/trackers/views.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.conf import settings
from django.http.response import Http404
from django.shortcuts import render
from django.utils.translation import gettext_lazy as _
from django.views.generic import ListView

from reports.models import Application, Report
from trackers.models import Tracker


def index(request):
    filter = request.GET.get('filter', None)
    try:
        if filter == 'apps':
            trackers = Tracker.objects.order_by('-apps_number')
        else:
            trackers = Tracker.objects.order_by('name')
    except Tracker.DoesNotExist:
        raise Http404(_("Tracker does not exist"))
    return render(request, 'trackers_list.html', {'trackers': trackers, 'filter': filter})


def detail(request, tracker_id):
    try:
        tracker = Tracker.objects.get(pk=tracker_id)
        # Add spaces aroung pipes for better rendering of signatures
        tracker.network_signature = tracker.network_signature.replace("|", " | ")
        tracker.code_signature = tracker.code_signature.replace("|", " | ")
    except Tracker.DoesNotExist:
        raise Http404(_("Tracker does not exist"))

    reports = Report.objects.filter(found_trackers=tracker_id).order_by('-creation_date')[:settings.EX_PAGINATOR_COUNT]

    data_to_render = {
        'tracker': tracker,
        'reports': reports,
    }
    return render(request, 'tracker_details.html', data_to_render)


def get_stats(request):
    NB_OF_TRACKERS_TO_DISPLAY = 21

    trackers = Tracker.objects.order_by('-apps_number', 'name')[0:NB_OF_TRACKERS_TO_DISPLAY]
    if trackers.count() == 0:
        raise Http404(_("Tracker does not exist"))

    return render(request, 'stats_details.html', {'trackers': trackers})


def graph(request):
    try:
        g = "digraph {<br>"
        reports = Report.objects.order_by('-creation_date')
        u_t = Tracker.objects.distinct('name')
        for t in u_t:
            g += "t%s[group=\"tracker\", label=\"%s\"];<br>" % (t.id, t.name)
        u_a = Application.objects.distinct('handle')
        for a in u_a:
            g += "a%s[group=\"app\", label=\"%s\"];<br>" % (a.id, a.handle)

        for r in reports:
            for t in r.found_trackers.all():
                g += "\ta%s -> t%s;<br>" % (r.application.id, t.id)

        g += "<br>}"
    except Tracker.DoesNotExist:
        raise Http404(_("Tracker does not exist"))
    return render(request, 'trackers_graph.html', {'g': g})


class TrackersListView(ListView):
    template_name = 'trackers_admin_list.html'
    context_object_name = 'trackers'

    def get_queryset(self):
        return Tracker.objects.order_by('-apps_number')

exodus/trackers/templates/stats_details.html
{% extends "base/base.html" %}
{% load i18n %}
{% block content %}
{% load static %}
<div class="row justify-content-md-center mb-4">
  {% if trackers %}
    <div class="col-lg-8">
      <div style="text-align:center">
        <h1 class="main-title">{% trans "Statistics" %}</h1>
        <span class="d-none d-md-block">
          <h4>{% trans "Most frequent trackers" %} - Google Play</h4>
        </span>
        <span class="d-md-none">
          <h4>{% trans "Most frequent trackers" %}</h4>
          <h5>(Google Play)</h5>
        </span>
      </div>
      <hr>
      <table style="margin: auto">
      {% for t in trackers %}
        <tr>
          <td class="text-right">
            <a href="{% url 'trackers:detail' t.id %}">{{ t.name }} </a>
          </td>
          <td class="small text-muted">
            {% blocktrans trimmed count count=t.apps_number %}
            found in {{ count }} application
            {% plural %}
            found in {{ count }} applications
            {% endblocktrans %}
          </td>
          <td style="width:250px">
            <div class="progress">
              <div class="progress-bar progress-bar-striped bg-{{ t.get_color_class }}" role="progressbar" style="width: {{ t.apps_percent }}%;" aria-valuenow="{{ t.apps_percent }}" aria-valuemin="0" aria-valuemax="100">{{ t.apps_percent }}%</div>
            </div>
          </td>
        </tr>
      {% endfor %}
      </table>
    </div>
  {% endif %}
</div>
{% endblock %}

exodus/trackers/templates/tracker_details.html
{% extends "base/base.html" %}
{% load i18n %}
{% load markdown %}
{% block content %}
<style>
  h2 {
    margin: 1.5rem 0 1rem 0;
  }
</style>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {{ tracker.name }}
    </h1>
    {% for c in tracker.category.all %}
      <span class="badge badge-pill badge-outline-primary">{{ c | lower }}</span>
    {% endfor %}
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-4">
    {% blocktrans trimmed count count=tracker.apps_number %}
    Present in: <b>{{ count }} application</b>
    {% plural %}
    Present in: <b>{{ count }} applications</b>
    {% endblocktrans %}
    <span class="badge badge-pill badge-{{ tracker.get_color_class }}">{{ tracker.apps_percent }} %</span>
  </div>
  <div class="col-md-8 col-12 mb-4 text-right">
    <a class="link main-link" target="_blank" rel="noreferrer" href="{{ tracker.website }}">{% trans "Tracker web page" %}</a>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-4">
    {{ tracker.description | markdown | safe }}
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-5">
    <h2>{% trans "Detection rules" %}</h2>
    {% trans "Code detection rule:" %} <code>{{ tracker.code_signature | default:"NC" }}</code>
    <br>
    {% trans "Network detection rule:" %} <code>{{ tracker.network_signature | default:"NC" }}</code>
  </div>
</div>

<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 mb-2">
    <h2>{% trans "Latest reports with this tracker" %}</h2>
  </div>
</div>

{% for report in reports %}
{% with report.application as app %}
<div class="row justify-content-sm-center position-relative mb-2">
  <div class="col-md-1 col-2 my-auto">
    <img src="/reports/{{ app.id }}/icon" width="50" class="rounded" alt="{{ app.handle }}">
  </div>
  <div class="col-md-7 col-8 text-truncate position-static">
    <div>
      <a href="{% url 'reports:detail' report.id %}" class="stretched-link report-link">
        {% if app.name.strip %}
        {{ app.name }}
        {% else %}
        {{ app.handle }}
        {% endif %}
      </a>
    </div>
    <div class="small"><b>{{ app.version }}{% if app.source %} - {{ app.source }}{% endif %}</b></div>
  </div>
</div>
{% endwith %}
{% endfor %}
{% endblock %}

exodus/trackers/templates/trackers_admin_list.html
{% extends "base/base.html"%}
{% load i18n %}
{% block content %}
<div class="row justify-content-md-center">
  <div class="col col-lg-10 col-centered">
    {% if request.user.is_superuser %}
    <table class="table table-hover">
      {% for tracker in trackers %}
      <tr>
        <td>
          <a href="{% url 'trackers:detail' tracker.id %}">{{ tracker.name }}</a>
        </td>
        <td>
          {{ tracker.code_signature | default:"NC" | truncatechars:55 }}
        </td>
        <td>
          {{ tracker.apps_number }}
        </td>
      </tr>
      {% endfor %}
    </table>
    {% else %}
    <div class="alert alert-danger small">
      <strong>{% trans "You need to be registered" %}.</strong>
    </div>
    {% endif %}
  </div>
</div>
{% endblock %}

exodus/trackers/templates/trackers_graph.html
{% if g %}
{{g|safe}}
{% endif %}

exodus/trackers/templates/trackers_list.html
{% extends "base/base.html"%}
{% load i18n %}
{% block content %}
{% if trackers %}
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12 text-center mb-4">
    <h1 class="main-title">
      {% trans "Trackers" %}
    </h1>
    <h4>
      {{ trackers.count }}
      {% blocktrans count counter=trackers.count %}known tracker{% plural %}known trackers{% endblocktrans %}
      - <a href="{% url 'trackers:get_stats' %}">{% trans "Statistics" %}</a>
    </h4>
  </div>
</div>
<div class="row justify-content-sm-center">
  <div class="col-md-8 col-12">
    <p>
      {% trans "Sorted by" %}&nbsp;
      <select class="custom-select"
        onchange="this.options[this.selectedIndex].value && (window.location = '/{{ LANGUAGE_CODE }}/trackers/' + this.options[this.selectedIndex].value);">
        <option value=" ">
          {% trans "Alphabetical order" %}
        </option>
        <option value="?filter=apps" {% if filter == 'apps' %}selected{% endif %}>
          {% trans "Number of applications" %}
        </option>
      </select>
    </p>

    {% for tracker in trackers %}
    <p class="mb-0">
      <a class="link black" href="{% url 'trackers:detail' tracker.id %}">
        {{ tracker.name }}&nbsp;
        <span class="badge badge-pill badge-{{ tracker.get_color_class }}">{{ tracker.apps_percent }} %</span>
      </a>
    </p>
    <p class="mb-0">
      <span class="small text-muted">
        {% blocktrans trimmed count count=tracker.apps_number %}
        found in {{ count }} application
        {% plural %}
        found in {{ count }} applications
        {% endblocktrans %}
      </span>
    </p>
    <p class="mb-4">
      {% for c in tracker.category.all %}
      <span class="badge badge-pill badge-outline-primary">{{ c | lower }}</span>
      {% endfor %}
    </p>
    {% endfor %}
  </div>
</div>
{% else %}
<p>{% trans "No trackers are available" %}.</p>
{% endif %}
{% endblock %}